/**
 * Copyright <2022> <Innovative Sensor Technology IST AG>
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 * 
 * 3. Neither the name of the copyright holder nor the names of its
 * contributors may be used to endorse or promote products derived from this
 * software without specific prior written permission.
 * 
 * 4. This license is granted under the laws of Switzerland, and the Courts of
 * Basle City shall have exclusive jurisdiction for any dispute arising in the
 * context of this license.  
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (EXCLUDING GROSS NEGLIGENCE AND INTENT
 * AS WELL AS OTHER MANDATORY LEGAL PROVISONS SUCH AS PRODUCT LIABILITY LAWS)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE.
 */
 
#ifndef _SW_MASTER_H_
#define _SW_MASTER_H_



#define I2C_WRITE  0
#define I2C_READ   1

#define I2C_ERROR  (unsigned char)0
#define I2C_OK     (unsigned char)1
#define I2C_OK_ACK (unsigned char)2   

#define SCL_PORT_	PORTA
#define SCL_PIN_	PINA
#define	SCL_DDR_ 	DDRA
#define	SCL_MASK_	(1<<PORTA2)
#define SDA_PORT_	PORTA
#define SDA_PIN_	PINA
#define	SDA_DDR_	DDRA
#define	SDA_MASK_	(1<<PORTA3)


typedef enum {
	I2C_SCL_STAY_LOW 		= 0x01,
	I2C_SDA_STAY_LOW 		= 0x02,
	I2C_WRONG_ADR			= 0x03,
} i2c_errorstate_t;


extern i2c_errorstate_t i2c_errorstate;


extern unsigned char init_i2c_master(void);

extern unsigned char i2c_master_write(unsigned char adr, unsigned char *msg, unsigned char nr_byte);

extern unsigned char i2c_master_read(unsigned char adr, unsigned char *recv, unsigned char nr_byte_read);


#endif
